
package com.jack;

import android.content.ContentValues;
import android.database.sqlite.SQLiteDatabase;

import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.jack.sqlite.DBHelper;
import com.jack.sqlite.TableProvider;

interface ConfigureInput {
  String dbName = "";
  Integer dbVersion = 1;
  String tableCreateQuery = "";
  String tableDeleteQuery = "";
  String tableName = "";
}

public class RNJackSqliteLibraryModule extends ReactContextBaseJavaModule {

  private final ReactApplicationContext reactContext;
  DBHelper dbHelper = null;

  public RNJackSqliteLibraryModule(ReactApplicationContext reactContext) {
    super(reactContext);
    this.reactContext = reactContext;
  }

  @ReactMethod
  public void configure(ConfigureInput configureInput, Callback successCallback, Callback errorCallback) {
    try {
      this.dbHelper = new DBHelper(getReactApplicationContext(), configureInput.dbName, configureInput.dbVersion,
              configureInput.tableCreateQuery, configureInput.tableDeleteQuery);

      TableProvider tableProvider = new TableProvider(this.dbHelper, configureInput.tableName);

      successCallback.invoke(tableProvider);
    } catch (Exception ex) {
      errorCallback.invoke(ex.getMessage());
    }
  }

  @ReactMethod
  public void create() {
    Sqlite.Helper dbHelper = new Sqlite.Helper(getReactApplicationContext());

    SQLiteDatabase db = dbHelper.getWritableDatabase();

    ContentValues values = new ContentValues();
    values.put(Sqlite.SqliteEntry.COLUMN_NAME_TITLE, "hello");
    values.put(Sqlite.SqliteEntry.COLUMN_NAME_SUBTITLE, "world");

    long newRowId = db.insert(Sqlite.SqliteEntry.TABLE_NAME, null, values);

    dbHelper.close();
  }

  @Override
  public String getName() {
    return "RNJackSqliteLibrary";
  }
}