package com.jack;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;

/**
 * Created by jacksonmalta on 11/04/19.
 */

public class Sqlite {
    private static final String SQL_CREATE_ENTRIES =
            "CREATE TABLE " + SqliteEntry.TABLE_NAME + " (" +
                    SqliteEntry._ID + " INTEGER PRIMARY KEY," +
                    SqliteEntry.COLUMN_NAME_TITLE + " TEXT," +
                    SqliteEntry.COLUMN_NAME_SUBTITLE + " TEXT)";

    private static final String SQL_DELETE_ENTRIES =
            "DROP TABLE IF EXISTS " + SqliteEntry.TABLE_NAME;

    public static class SqliteEntry implements BaseColumns {
        public static final String TABLE_NAME = "sale";
        public static final String COLUMN_NAME_TITLE = "title";
        public static final String COLUMN_NAME_SUBTITLE = "subtitle";
    }

    public static class Helper extends SQLiteOpenHelper {

        public static final int DATABASE_VERSION = 1;
        public static final String DATABASE_NAME = "Jack.db";

        public Helper(Context context) {
            super(context, DATABASE_NAME, null, DATABASE_VERSION);
        }

        @Override
        public void onCreate(SQLiteDatabase db) {
            db.execSQL(SQL_CREATE_ENTRIES);
        }

        @Override
        public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
            db.execSQL(SQL_DELETE_ENTRIES);
            onCreate(db);
        }

    }
}
